ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.8 by greg, Sat Jan 29 16:44:01 2011 UTC vs.
Revision 2.19 by greg, Fri Jun 3 19:41:14 2011 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + use File::Temp qw/ :mktemp  /;
10   sub userror {
11 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-dim xmin xmax ymin ymax zmin zmax][{+|-}mgf][{+|-}geom] [input ..]\n";
11 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
12          exit 1;
13   }
14 < my $td = `mktemp -d /tmp/genBSDF.XXXXXX`;
14 > my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15   chomp $td;
16 + my $tensortree = 0;
17 + my $ttlog2 = 4;
18   my $nsamp = 1000;
19 + my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
20   my $mgfin = 0;
21   my $geout = 1;
22   my $nproc = 1;
23 + my $doforw = 0;
24 + my $doback = 1;
25   my @dim;
26   # Get options
27   while ($#ARGV >= 0) {
28          if ("$ARGV[0]" =~ /^[-+]m/) {
29                  $mgfin = ("$ARGV[0]" =~ /^\+/);
30 +        } elsif ("$ARGV[0]" eq "-r") {
31 +                $rtargs = "$rtargs $ARGV[1]";
32 +                shift @ARGV;
33          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
34                  $geout = ("$ARGV[0]" =~ /^\+/);
35 +        } elsif ("$ARGV[0]" =~ /^[-+]f/) {
36 +                $doforw = ("$ARGV[0]" =~ /^\+/);
37 +        } elsif ("$ARGV[0]" =~ /^[-+]b/) {
38 +                $doback = ("$ARGV[0]" =~ /^\+/);
39 +        } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
40 +                $tensortree = substr($ARGV[0], 2, 1);
41 +                $ttlog2 = $ARGV[1];
42 +                shift @ARGV;
43          } elsif ("$ARGV[0]" eq "-c") {
44                  $nsamp = $ARGV[1];
45                  shift @ARGV;
# Line 40 | Line 57 | while ($#ARGV >= 0) {
57          }
58          shift @ARGV;
59   }
60 + # Check that we're actually being asked to do something
61 + die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
62 + # Name our own persist file?
63 + my $persistfile;
64 + if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
65 +        $persistfile = "$td/pfile.txt";
66 +        $rtargs = "-PP $persistfile $rtargs";
67 + }
68   # Get scene description and dimensions
69   my $radscn = "$td/device.rad";
70   my $mgfscn = "$td/device.mgf";
# Line 49 | Line 74 | if ( $mgfin ) {
74          die "Could not load MGF input\n" if ( $? );
75          system "mgf2rad $mgfscn > $radscn";
76   } else {
77 <        system "cat @ARGV | xform -e > $radscn";
77 >        system "xform -e @ARGV > $radscn";
78          die "Could not load Radiance input\n" if ( $? );
79          system "rad2mgf $radscn > $mgfscn" if ( $geout );
80   }
# Line 57 | Line 82 | if ($#dim != 5) {
82          @dim = split ' ', `getbbox -h $radscn`;
83   }
84   print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
85 < # Add receiver surface (rectangle)
86 < my $modnm="_receiver_black_";
85 > # Add receiver surfaces (rectangular)
86 > my $fmodnm="receiver_face";
87 > my $bmodnm="receiver_behind";
88   open(RADSCN, ">> $radscn");
89 < print RADSCN "void glow $modnm\n0\n0\n4 0 0 0 0\n\n";
90 < print RADSCN "$modnm polygon _receiver_\n0\n0\n12\n";
91 < print RADSCN "\t",$dim[0],"\t",$dim[2],"\t",$dim[5]+1e-5,"\n";
92 < print RADSCN "\t",$dim[0],"\t",$dim[3],"\t",$dim[5]+1e-5,"\n";
67 < print RADSCN "\t",$dim[1],"\t",$dim[3],"\t",$dim[5]+1e-5,"\n";
68 < print RADSCN "\t",$dim[1],"\t",$dim[2],"\t",$dim[5]+1e-5,"\n";
89 > print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
90 > print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
91 > print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
92 > print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
93   close RADSCN;
94   # Generate octree
95   system "oconv -w $radscn > $octree";
96   die "Could not compile scene\n" if ( $? );
97 < # Set up sampling
97 > # Output XML prologue
98 > print
99 > '<?xml version="1.0" encoding="UTF-8"?>
100 > <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
101 > <WindowElementType>System</WindowElementType>
102 > <Optical>
103 > <Layer>
104 >        <Material>
105 >                <Name>Name</Name>
106 >                <Manufacturer>Manufacturer</Manufacturer>
107 > ';
108 > printf "\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
109 > printf "\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
110 > printf "\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
111 > print "\t\t<DeviceType>Integral</DeviceType>\n";
112 > # Output MGF description if requested
113 > if ( $geout ) {
114 >        print "\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
115 >        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
116 >        open(MGFSCN, "< $mgfscn");
117 >        while (<MGFSCN>) { print $_; }
118 >        close MGFSCN;
119 >        print "xf\n";
120 >        print "\t\t</Geometry>\n";
121 > }
122 > print " </Material>\n";
123 > # Set up surface sampling
124 > my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
125 > my $ny = int($nsamp/$nx + .5);
126 > $nsamp = $nx * $ny;
127 > my $ns = 2**$ttlog2;
128 > my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
129 > # Create data segments (all the work happens here)
130 > if ( $tensortree ) {
131 >        do_tree_bsdf();
132 > } else {
133 >        do_matrix_bsdf();
134 > }
135 > # Output XML epilogue
136 > print
137 > '</Layer>
138 > </Optical>
139 > </WindowElement>
140 > ';
141 > # Clean up temporary files and exit
142 > if ( $persistfile && open(PFI, "< $persistfile") ) {
143 >        while (<PFI>) {
144 >                s/^[^ ]* //;
145 >                kill('ALRM', $_);
146 >                last;
147 >        }
148 >        close PFI;
149 > }
150 > exec("rm -rf $td");
151 >
152 > #-------------- End of main program segment --------------#
153 >
154 > #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
155 > sub do_tree_bsdf {
156 > # Get sampling rate and subdivide task
157 > my $ns2 = $ns;
158 > $ns2 /= 2 if ( $tensortree == 3 );
159 > @pdiv = (0, int($ns2/$nproc));
160 > my $nrem = $ns2 % $nproc;
161 > for (my $i = 1; $i < $nproc; $i++) {
162 >        my $nv = $pdiv[$i] + $pdiv[1];
163 >        ++$nv if ( $nrem-- > 0 );
164 >        push @pdiv, $nv;
165 > }
166 > die "Script error 1" if ($pdiv[-1] != $ns2);
167 > # Shirley-Chiu mapping from unit square to disk
168 > $sq2disk = '
169 > in_square_a = 2*in_square_x - 1;
170 > in_square_b = 2*in_square_y - 1;
171 > in_square_rgn = if(in_square_a + in_square_b,
172 >                        if(in_square_a - in_square_b, 1, 2),
173 >                        if(in_square_b - in_square_a, 3, 4));
174 > out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
175 >                        -in_square_a, -in_square_b);
176 > out_disk_phi = PI/4 * select(in_square_rgn,
177 >                                in_square_b/in_square_a,
178 >                                2 - in_square_a/in_square_b,
179 >                                4 + in_square_b/in_square_a,
180 >                                if(in_square_b*in_square_b,
181 >                                        6 - in_square_a/in_square_b, 0));
182 > Dx = out_disk_r*cos(out_disk_phi);
183 > Dy = out_disk_r*sin(out_disk_phi);
184 > Dz = sqrt(1 - out_disk_r*out_disk_r);
185 > ';
186 > # Shirley-Chiu mapping from unit disk to square
187 > $disk2sq = '
188 > norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
189 > in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
190 > in_disk_phi = norm_radians(atan2(Dy, Dx));
191 > in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
192 > out_square_a = select(in_disk_rgn,
193 >                        in_disk_r,
194 >                        (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
195 >                        -in_disk_r,
196 >                        (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
197 > out_square_b = select(in_disk_rgn,
198 >                        in_disk_phi*in_disk_r/(PI/4),
199 >                        in_disk_r,
200 >                        (PI - in_disk_phi)*in_disk_r/(PI/4),
201 >                        -in_disk_r);
202 > out_square_x = (out_square_a + 1)/2;
203 > out_square_y = (out_square_b + 1)/2;
204 > ';
205 > # Announce ourselves in XML output
206 > print "\t<DataDefinition>\n";
207 > print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
208 > print "\t</DataDefinition>\n";
209 > # Fork parallel rtcontrib processes to compute each side
210 > if ( $doback ) {
211 >        for (my $proc = 0; $proc < $nproc; $proc++) {
212 >                bg_tree_rtcontrib(0, $proc);
213 >        }
214 >        while (wait() >= 0) {
215 >                die "rtcontrib process reported error" if ( $? );
216 >        }
217 >        ttree_out(0);
218 > }
219 > if ( $doforw ) {
220 >        for (my $proc = 0; $proc < $nproc; $proc++) {
221 >                bg_tree_rtcontrib(1, $proc);
222 >        }
223 >        while (wait() >= 0) {
224 >                die "rtcontrib process reported error" if ( $? );
225 >        }
226 >        ttree_out(1);
227 > }
228 > }       # end of sub do_tree_bsdf()
229 >
230 > # Run i'th rtcontrib process for generating tensor tree samples
231 > sub bg_tree_rtcontrib {
232 >        my $pid = fork();
233 >        die "Cannot fork new process" unless defined $pid;
234 >        if ($pid > 0) { return $pid; }
235 >        my $forw = shift;
236 >        my $pn = shift;
237 >        my $pbeg = $pdiv[$pn];
238 >        my $plen = $pdiv[$pn+1] - $pbeg;
239 >        my $matargs = "-m $bmodnm";
240 >        if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
241 >        my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
242 >                "-e '$disk2sq' -bn '$ns*$ns' " .
243 >                "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
244 >                "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
245 >        if ( $tensortree == 3 ) {
246 >                # Isotropic BSDF
247 >                $cmd = "cnt $plen $ny $nx " .
248 >                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
249 >                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
250 >                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
251 >                        "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
252 >                        "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
253 >                        "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
254 >                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
255 >                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
256 >                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
257 >                        "| $cmd";
258 >        } else {
259 >                # Anisotropic BSDF
260 >                # Sample area vertically to improve load balance, since
261 >                # shading systems usually have bilateral symmetry (L-R)
262 >                $cmd = "cnt $plen $ns $ny $nx " .
263 >                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
264 >                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
265 >                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
266 >                        "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
267 >                        "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
268 >                        "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
269 >                        "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
270 >                        "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
271 >                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
272 >                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
273 >                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
274 >                        "| $cmd";
275 >        }
276 > # print STDERR "Starting: $cmd\n";
277 >        exec($cmd);             # no return; status report to parent via wait
278 >        die "Cannot exec: $cmd\n";
279 > }       # end of bg_tree_rtcontrib()
280 >
281 > # Simplify and output tensor tree results
282 > sub ttree_out {
283 >        my $forw = shift;
284 >        my $side = ("Back","Front")[$forw];
285 > # Only output one transmitted distribution, preferring backwards
286 > if ( !$forw || !$doback ) {
287 > print
288 > '       <WavelengthData>
289 >                <LayerNumber>System</LayerNumber>
290 >                <Wavelength unit="Integral">Visible</Wavelength>
291 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
292 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
293 >                <WavelengthDataBlock>
294 >                        <WavelengthDataDirection>Transmission</WavelengthDataDirection>
295 >                        <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
296 >                        <ScatteringDataType>BTDF</ScatteringDataType>
297 >                        <ScatteringData>
298 > ';
299 > system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
300 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
301 >        "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
302 >        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
303 > die "Failure running rttree_reduce" if ( $? );
304 > print
305 > '                       </ScatteringData>
306 >                </WavelengthDataBlock>
307 >        </WavelengthData>
308 > ';
309 > }
310 > # Output reflection
311 > print
312 > '       <WavelengthData>
313 >                <LayerNumber>System</LayerNumber>
314 >                <Wavelength unit="Integral">Visible</Wavelength>
315 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
316 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
317 >                <WavelengthDataBlock>
318 > ';
319 > print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
320 > print '                 <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
321 >                        <ScatteringDataType>BRDF</ScatteringDataType>
322 >                        <ScatteringData>
323 > ';
324 > system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
325 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
326 >        "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
327 >        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
328 > die "Failure running rttree_reduce" if ( $? );
329 > print
330 > '                       </ScatteringData>
331 >                </WavelengthDataBlock>
332 >        </WavelengthData>
333 > ';
334 > }       # end of ttree_out()
335 >
336 > #------------- End of do_tree_bsdf() & subroutines -------------#
337 >
338 > #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
339 > sub do_matrix_bsdf {
340 > # Set up sampling of portal
341   # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
342 < my $tcal = '
342 > $tcal = '
343   DEGREE : PI/180;
344   sq(x) : x*x;
345   Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
# Line 85 | Line 352 | Kcol = Kbin - Kaccum(Krow-1);
352   Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
353   Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
354   sin_kpol = sin(Kpol);
355 < Dx = -cos(Kazi)*sin_kpol;
355 > Dx = cos(Kazi)*sin_kpol;
356   Dy = sin(Kazi)*sin_kpol;
357   Dz = sqrt(1 - sin_kpol*sin_kpol);
358   KprojOmega = PI * if(Kbin-.5,
359          (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
360          1 - sq(cos(Kpola(1)*DEGREE)));
361   ';
362 < # Compute Klems bin from exiting ray direction
363 < my $kcal = '
362 > # Compute Klems bin from exiting ray direction (forward or backward)
363 > $kcal = '
364   DEGREE : PI/180;
365 + abs(x) : if(x, x, -x);
366   Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
367   posangle(a) : if(-a, a + 2*PI, a);
368   Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
# Line 115 | Line 383 | kbin2(pol,azi) = select(kfindrow(1, pol),
383                  kaccum(7) + kazn(azi,360/knaz(8)),
384                  kaccum(8) + kazn(azi,360/knaz(9))
385          );
386 < kbin = kbin2(Acos(Dz), Atan2(Dy, -Dx));
386 > kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
387   ';
388   my $ndiv = 145;
121 my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
122 my $ny = int($nsamp/$nx + .5);
123 $nsamp = $nx * $ny;
389   # Compute scattering data using rtcontrib
390 < my $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
390 > my @tfarr;
391 > my @rfarr;
392 > my @tbarr;
393 > my @rbarr;
394 > my $cmd;
395 > my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
396 >        "-e '$kcal' -b kbin -bn $ndiv " .
397 >        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
398 > my $rccmd = "rcalc -e '$tcal' " .
399 >        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
400 >        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
401 > if ( $doforw ) {
402 > $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
403 >        "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
404 >        "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
405 >        "-e 'zp:$dim[4]' " .
406 >        q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
407 >        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
408 >        "| $rtcmd";
409 > system "$cmd" || die "Failure running: $cmd\n";
410 > @tfarr = `$rccmd $td/$fmodnm.flt`;
411 > die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
412 > @rfarr = `$rccmd $td/$bmodnm.flt`;
413 > die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
414 > }
415 > if ( $doback ) {
416 > $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
417          "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
418          "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
419 <        "-e 'zp:$dim[4]-1e-5' " .
419 >        "-e 'zp:$dim[5]' " .
420          q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
421 <        q{-e '$1=xp;$2=yp;$3=zp;$4=Dx;$5=Dy;$6=Dz' } .
422 <        "| rtcontrib -h -ff -n $nproc -c $nsamp -e '$kcal' -b kbin -bn $ndiv " .
423 <        "-m $modnm -w -ab 5 -ad 700 -lw 3e-6 $octree " .
424 <        "| rcalc -e '$tcal' " .
425 <        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
426 <        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
427 < my @darr = `$cmd`;
137 < die "Failure running: $cmd\n" if ( $? );
138 < # Output XML prologue
139 < print
140 < '<?xml version="1.0" encoding="UTF-8"?>
141 < <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
142 <        <WindowElementType>System</WindowElementType>
143 <        <Optical>
144 <                <Layer>
145 <                <Material>
146 <                        <Name>Name</Name>
147 <                        <Manufacturer>Manufacturer</Manufacturer>
148 < ';
149 < printf "\t\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
150 < printf "\t\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
151 < printf "\t\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
152 < print "\t\t\t<DeviceType>Integral</DeviceType>\n";
153 < # Output MGF description if requested
154 < if ( $geout ) {
155 <        print "\t\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
156 <        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
157 <        system "cat $mgfscn";
158 <        print "xf\n";
159 <        print "\t\t\t</Geometry>\n";
421 >        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
422 >        "| $rtcmd";
423 > system "$cmd" || die "Failure running: $cmd\n";
424 > @tbarr = `$rccmd $td/$bmodnm.flt`;
425 > die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
426 > @rbarr = `$rccmd $td/$fmodnm.flt`;
427 > die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
428   }
429 < print '                 </Material>
430 <                <DataDefinition>
431 <                        <IncidentDataStructure>Columns</IncidentDataStructure>
432 <                        <AngleBasis>
429 > # Output angle basis
430 > print
431 > '       <DataDefinition>
432 >                <IncidentDataStructure>Columns</IncidentDataStructure>
433 >                <AngleBasis>
434                          <AngleBasisName>LBNL/Klems Full</AngleBasisName>
435 <                                <AngleBasisBlock>
435 >                        <AngleBasisBlock>
436                                  <Theta>0</Theta>
437                                  <nPhis>1</nPhis>
438                                  <ThetaBounds>
439 <                                <LowerTheta>0</LowerTheta>
440 <                                <UpperTheta>5</UpperTheta>
439 >                                        <LowerTheta>0</LowerTheta>
440 >                                        <UpperTheta>5</UpperTheta>
441                                  </ThetaBounds>
442                                  </AngleBasisBlock>
443                                  <AngleBasisBlock>
# Line 237 | Line 506 | print '                        </Material>
506                          </AngleBasisBlock>
507                  </AngleBasis>
508          </DataDefinition>
509 <        <WavelengthData>
509 > ';
510 > if ( $doforw ) {
511 > print
512 > '       <WavelengthData>
513                  <LayerNumber>System</LayerNumber>
514                  <Wavelength unit="Integral">Visible</Wavelength>
515                  <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
# Line 249 | Line 521 | print '                        </Material>
521                          <ScatteringDataType>BTDF</ScatteringDataType>
522                          <ScatteringData>
523   ';
524 < # Output computed data (transposed order)
524 > # Output front transmission (transposed order)
525   for (my $od = 0; $od < $ndiv; $od++) {
526          for (my $id = 0; $id < $ndiv; $id++) {
527 <                print $darr[$ndiv*$id + $od];
527 >                print $tfarr[$ndiv*$id + $od];
528          }
529          print "\n";
530   }
259 # Output XML epilogue
531   print
532 < '               </ScatteringData>
533 <        </WavelengthDataBlock>
532 > '                       </ScatteringData>
533 >                </WavelengthDataBlock>
534          </WavelengthData>
535 < </Layer>
536 < </Optical>
537 < </WindowElement>
535 >        <WavelengthData>
536 >                <LayerNumber>System</LayerNumber>
537 >                <Wavelength unit="Integral">Visible</Wavelength>
538 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
539 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
540 >                <WavelengthDataBlock>
541 >                        <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
542 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
543 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
544 >                        <ScatteringDataType>BRDF</ScatteringDataType>
545 >                        <ScatteringData>
546   ';
547 < # Clean up temporary files
548 < system "rm -rf $td";
547 > # Output front reflection (transposed order)
548 > for (my $od = 0; $od < $ndiv; $od++) {
549 >        for (my $id = 0; $id < $ndiv; $id++) {
550 >                print $rfarr[$ndiv*$id + $od];
551 >        }
552 >        print "\n";
553 > }
554 > print
555 > '                       </ScatteringData>
556 >                </WavelengthDataBlock>
557 >        </WavelengthData>
558 > ';
559 > }
560 > if ( $doback ) {
561 > print
562 > '       <WavelengthData>
563 >                <LayerNumber>System</LayerNumber>
564 >                <Wavelength unit="Integral">Visible</Wavelength>
565 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
566 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
567 >                <WavelengthDataBlock>
568 >                        <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
569 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
570 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
571 >                        <ScatteringDataType>BTDF</ScatteringDataType>
572 >                        <ScatteringData>
573 > ';
574 > # Output back transmission (transposed order)
575 > for (my $od = 0; $od < $ndiv; $od++) {
576 >        for (my $id = 0; $id < $ndiv; $id++) {
577 >                print $tbarr[$ndiv*$id + $od];
578 >        }
579 >        print "\n";
580 > }
581 > print
582 > '                       </ScatteringData>
583 >                </WavelengthDataBlock>
584 >        </WavelengthData>
585 >        <WavelengthData>
586 >                <LayerNumber>System</LayerNumber>
587 >                <Wavelength unit="Integral">Visible</Wavelength>
588 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
589 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
590 >                <WavelengthDataBlock>
591 >                        <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
592 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
593 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
594 >                        <ScatteringDataType>BRDF</ScatteringDataType>
595 >                        <ScatteringData>
596 > ';
597 > # Output back reflection (transposed order)
598 > for (my $od = 0; $od < $ndiv; $od++) {
599 >        for (my $id = 0; $id < $ndiv; $id++) {
600 >                print $rbarr[$ndiv*$id + $od];
601 >        }
602 >        print "\n";
603 > }
604 > print
605 > '                       </ScatteringData>
606 >                </WavelengthDataBlock>
607 >        </WavelengthData>
608 > ';
609 > }
610 > }
611 > #------------- End of do_matrix_bsdf() --------------#

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines